% Linear Gaussian CPD p(y|x) = N(Y|a + bx, sigma) where a is
% the offset and b is the slope. 

sigma = 1;
a = 1; 
b = 0.5;
stepSize = 0.01; 
[x,y] = meshgrid(0:stepSize:10,0:stepSize:10);
[r,c]=size(x);

func = @(X,Y)normpdf(Y,a + b*X,sigma);

p = func(x(:),y(:));
p = reshape(p, r, c);

fontSize = {'FontSize',14};

figure;
mesh(x,y,p);
shading interp;
lighting phong;
material dull;
view([-47.5 34]);
xlabel('X',fontSize{:});
ylabel('Y',fontSize{:});
zlabel('P(Y | X)',fontSize{:});
set(gca,'XTick',[0,5,10],'YTick',[0,5,10],'ZTick',0:0.1:0.5);
set(gca,fontSize{:},'LineWidth',1.5);
