function removePMTKmex()
    % Remove all mex files generated by compilePMTKmex().
    savedDir = pwd;
    mfiles = findAllFilesWithTag('#PMTKmex');
    mfiles(ismember(mfiles,'compilePMTKmex.m')) = [];
    mfiles(ismember(mfiles,'removePMTKmex.m' )) = [];
    for i=1:numel(mfiles)
        file = mfiles{i};
        mexFileName = [file(1:end-1),mexext];
        if(exist(mexFileName,'file'))
            try
                cd(fileparts(which(file)));
                fprintf('Removing %s\n',mexFileName);
                clear mex;
                delete(mexFileName);
            catch
                fprintf('Could not delete %s\n',mexFileName);
            end
        else
            fprintf('Could not find %s\n',mexFileName);
        end
    end
    
    if ~ismac
        fprintf('\n\n ...removing lightspeed mex files...\n\n');
        cd(fullfile(PMTKroot,'util','lightspeed2.2'));
        files = ls(['*.',mexext]);
        clear mex;
        for i=1:size(files,1)
           mexFileName = deblank(files(i,:));
           try
                fprintf('Removing %s\n',mexFileName);
                delete(mexFileName);
           catch
                fprintf('Could not find %s\n',mexFileName);
           end
        end
    end
    cd(savedDir);
end